;;; $Id$

(module m2
  ;; import everything exported from f that is: f2, compute and get-bar.
  (import (f "f.scm"))
  ;; export the current f1 towards eval (there's a single eval per system):
  (eval (export f1))
  ;; the 'main' entry point:
  (main start) )

(define (start argl)
  (display "This is m2: ")
  (write (f1 44))
  (write (equal? (f1 44) '("f1@m2" 44)))
  (newline)
  (write (f2 33))
  (write (equal? (f2 33) '("f2@f" 33 (m1 (f1 x)) ("f1@m1" 33))))
  (newline)
  ;; check that f2 is immutable:
  (set! f2 (lambda (x) x))
  (write (f2 33))
  (write (equal? 33 (f2 33)))
  (newline)
  ;; compute and get-bar are immutable but an assignment will be caught
  ;; directly by the compiler:
  ;(set! compute f2)
  ;; Check compute:
  (write (compute '(f1 44)))
  (write (equal? (compute '(f1 44)) '("f1@m2" 44)))
  (newline)
  ;; let us give a value to bar (and check that f2 is available):
  (write (compute '(define bar (f2 33))))
  (write (equal? (compute '(f2 33)) '("f2@f" 33 (m1 (f1 x)) ("f1@m1" 33))))
  (newline)
  ;; obtain it via eval:
  (write (compute 'bar))
  (write (equal? (compute 'bar) '("f2@f" 33 (m1 (f1 x)) ("f1@m1" 33))))
  (newline)
  ;; check that we really share it:
  (write (get-bar))
  (write (equal? (get-bar) '("f2@f" 33 (m1 (f1 x)) ("f1@m1" 33))))
  (newline)
  ;; check that get-bar is not available to eval:
  (write
   (try (compute '(get-bar))
        (lambda (k . all) (k #t)) ) )
  (newline)
  'done )

;;; This is not a redefinition since f1 is not imported from m1:

(define (f1 x)
  (list "f1@m2" x) )

;;; end of m2.scm
